#!/usr/bin/wish
menu .mbar -tearoff 0
. configure -menu .mbar
.mbar add cascade -menu .mbar.apple
menu .mbar.apple -tearoff 0
.mbar.apple add command -label "About TreeBank Search" -command about
.mbar add cascade -menu .mbar.edit -label Edit
    menu .mbar.edit -tearoff 0
    .mbar.edit add command -label Cut -accel Command-X -command {
        event generate [focus] <<Cut>>
    }
    .mbar.edit add command -label Copy -accel Command-C -command {
        event generate [focus] <<Copy>>
    }
    .mbar.edit add command -label Paste -accel Command-V -command {
        event generate [focus] <<Paste>>
    }
    .mbar.edit add command -label Clear -command {
        event generate [focus] <<Clear>>
    }
.mbar add cascade -menu .mbar.help -label Help
menu .mbar.help -tearoff 0
.mbar.help add command -label "TreeBank Search Usage Homepage" -command homepage
if {[catch {package require Tclapplescript}]} {
    tk_messageBox -type ok -message [format "WARNING\n Applescript support not found in the current Tcl/Tk package.\n Tcl/Tk version: %s\n You may update Tcl/Tk from http://tcltkaqua.sourceforge.net/" [info tclversion]]
    proc about {} {
	tk_messageBox -type ok -message "TreeBank Search\nJan 2007 ($5 machine license fee version)\n Sandiway Fong\n University of Arizona\n Built on Tcl/Tk and Sicstus Prolog"
    }
    proc homepage {} {
	tk_messageBox -type ok -message "For instructions, please see:\n http://dingo.sbs.arizona.edu/~sandiway/treebanksearch/usage.html"
    }
} else {
    if {[info commands console] != ""} {
	console hide
    }
    proc about {} {
	AppleScript execute {
	    display dialog "TreeBank Search\nJan 2007 ($5 machine license fee version)\rSandiway Fong\rUniversity of Arizona\r\rBuilt on Tcl/Tk and Sicstus Prolog" with icon file "treebanksearch.icns" buttons { "OK" } default button "OK" with title "About Treebank Search"
	}
    }
    proc homepage {} {
	AppleScript execute {
	    open location "http://dingo.sbs.arizona.edu/~sandiway/treebanksearch/usage.html"
	}
    }
}
set vsep 15
set WEIGHT "normal"
set SLANT "roman"
set minbr 50 
set hsep 5
set node1 0
set node2 0
set drop 20
set arrows ""
set arrowsids ""
set trees ""
set max 0

image create photo logo -data "R0lGODlhvAAYAMQQAICAgEBAQPDw8NDQ0ODg4DAwMCAgIGBgYBAQEKCgoHBwcJCQ
kLCwsFBQUMDAwAAAAP///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAACH5BAEAABAALAAAAAC8ABgAAAX/ICSOZGmeaKqubOu+cCzP
dG3feK7vfO//wKBwSCwaj8ikcslsOp/QqFQ5SFWn2IHDIcDGAo+weJwUFMZiAyAq
OCDGBUDC21IA7odH4A5ojLRbgVcjgYVbVwKGgXMjYHx8Bg8LJYlbJgRbBCRamiKY
DiOVgyUEbwcMWwCRnRCfigykhyaKDqwkopRbXX8Oo4QPa7NoYQckAMNhoCJgyCRg
JgJ6JgUGBSdhow4PJcB/CAG7JnnKxtzIAZQPBgomx8OMng1jaoMB6CTa5PjdwvoK
D6yOnWBl75KzbSUGPCiGD4FCWyIeUAunjVuwBfxQgAmXIuMIiAACJDDQDqEIAQFI
/4oYgKAALAgD3IQruE/fr2Al8tUcIVAFzRRg7AkFU8BXgzUBGJJ44KBAgV0VlwIQ
0ACBTRP/1j266hGFVQEI4InoydPkxJzO7v26CkEbzn0LCuUJd8zQy0YFCjHwFXRo
AAQI7rYC2JbwUi4FGEYd8aCBAQMIOJ4wg8zAqIWFJpUYOVZlWUNOVz4QeyLlIwDj
TrhVPcyAWHdj3kJgNsbmM0oFIo9QoDQpN1As2S2O2O2nigGnz1hjPGwaI7CvhxUV
odPnt6Fn2K7uRx0BSJMrSxgXAPF2ibon34zRzViZwgTDITxgBwGsZhQEfIk4I3VT
zmFqQUAWAMt5Mho0af2nXeJX1DE1wgEBCgheaRGaYB4J8lyRQF6FqHHYCAkAM2FG
DDyg34N5JYSAZ/LJVsIBB+jl4FjgediIAZKB00iE1f3nYmHk2GcMU7TgRUs9wJwW
1AiubcaefPpgNOJbCuCIgirqHAXhAw4tFaMhjBBg2INqkVXYIKUYEJcDCYDRG48z
brbQCSG+1qUIeSATDGXIKMMnGgYcsAtGEIlJn5hiCbDKR3MyKigKAixAWwEKcCQm
Mgg18JScL+VhSwCbnqTAGeocwIoZoYpQ5xEQDUSHD62+KuustNZq66245qrrrrz2
WkIIADs="
image create photo logo2 -data "R0lGODlhywIYANUgAL+Ng55TRN/Gwffy8MDAwOfV0e/j4bd/c69wZKZiVJZFNc+q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"

frame .f

frame .f.f
label .f.f.logo -image logo
bind .f.f.logo <Enter> ".f.f.logo configure -image logo2"
bind .f.f.logo <Leave> ".f.f.logo configure -image logo"
pack .f.f.logo -anchor nw

set f1 "No file set"
set f2 "No file set"
set p1 ""
set p2 ""
set selected 0

frame .f.f.f
button .f.f.f.b1 -text "Sentence File" -command {set f1 [tk_getOpenFile -title "Sentence File"]}
entry .f.f.f.f1 -width 32 -textvariable f1
button .f.f.f.b2 -text "Prolog Tree File" -command {set f2 [tk_getOpenFile -title "Prolog Tree File"]}
entry .f.f.f.f2 -width 32 -textvariable f2
button .f.f.f.b3 -text "Load Files" -command {textfile $f1 $f2}
grid .f.f.f.b1 .f.f.f.f1 .f.f.f.b2 .f.f.f.f2 .f.f.f.b3

frame .f.f.f2
label .f.f.f2.lb1 -text "Match Sentence"
entry .f.f.f2.f3 -width 10 -textvariable p1
bind .f.f.f2.f3 <KeyPress-Return> do_text_search
bind .f.f.f2.f3 <KeyPress-Tab> do_text_search
checkbutton .f.f.f2.cb1 -text "regexp"

set ss "Down"
menubutton .f.f.f2.mb1 -menu .f.f.f2.mb1.m -textvariable ss
menu .f.f.f2.mb1.m 
.f.f.f2.mb1.m add command -label "Down" -command text_search_down
.f.f.f2.mb1.m add command -label "Up" -command text_search_up
.f.f.f2.mb1.m add command -label "All" -command text_search_all

button .f.f.f2.b -text "Enable" -command {load_treebank $f2}
label .f.f.f2.lb2 -text "Match Tree (Prolog)" -state disabled
entry .f.f.f2.f4 -width 30 -textvariable p2 -state disabled
bind .f.f.f2.f4 <KeyPress-Return> do_tree_search

set ts "One"
menubutton .f.f.f2.mb2 -menu .f.f.f2.mb2.m -textvariable ts -state disabled
menu .f.f.f2.mb2.m 
.f.f.f2.mb2.m add command -label "One" -command tree_search_one
.f.f.f2.mb2.m add command -label "All" -command tree_search_all

grid .f.f.f2.lb1 .f.f.f2.f3 .f.f.f2.cb1 .f.f.f2.mb1 .f.f.f2.b .f.f.f2.lb2 .f.f.f2.f4 .f.f.f2.mb2

set cnt 0
set sel "(none)"
set selt "(none)"
set ff 1
frame .f.f.f3
label .f.f.f3.lb1 -text "Sentences:"
label .f.f.f3.lb2 -textvariable cnt -foreground blue
label .f.f.f3.lb3 -text "Selected:"  -foreground grey
label .f.f.f3.lb4 -textvariable sel -foreground grey
label .f.f.f3.lb5 -text "Show:"  -foreground grey
button .f.f.f3.b1 -text "Selected Only" -state disabled -command show_selected 
button .f.f.f3.b2 -text "All" -state disabled -command show_all 
label .f.f.f3.lb6 -text "Displayed Tree:" 
entry .f.f.f3.lb7 -width 6 -textvariable selt -foreground blue
bind .f.f.f3.lb7 <KeyPress-Return> goto_tree
label .f.f.f3.lb8 -text "Zoom: (x1)" 
scale .f.f.f3.s -from 1 -to 4 -resolution 0.5 -variable ff -command redrawtree -orient horizontal -length 100 -showvalue false
label .f.f.f3.lb9 -text "(x4)" 
button .f.f.f3.lb10 -text "Viewer Sync" -command do_sync
grid .f.f.f3.lb1 .f.f.f3.lb2 .f.f.f3.lb3 .f.f.f3.lb4 .f.f.f3.lb5 .f.f.f3.b1 .f.f.f3.b2 .f.f.f3.lb6 .f.f.f3.lb7 .f.f.f3.lb8 .f.f.f3.s .f.f.f3.lb9 .f.f.f3.lb10
pack .f.f.f 
pack .f.f.f2 -anchor nw
pack .f.f.f3 -anchor nw

panedwindow .f.uf

frame .f.uf.f3
frame .f.uf.f3.cf
font create sentencefont -family system -size 12
text .f.uf.f3.cf.c -undo false -width 40 -font sentencefont -wrap none -xscrollcommand ".f.uf.f3.x set" -yscrollcommand ".f.uf.f3.cf.y set"
scrollbar .f.uf.f3.cf.y -command ".f.uf.f3.cf.c yview" -orient v -bd 1 -relief sunken
pack .f.uf.f3.cf.c .f.uf.f3.cf.y -side left
pack .f.uf.f3.cf.y -side right
pack .f.uf.f3.cf.c -fill both -expand 1 -anchor ne
pack .f.uf.f3.cf.y -fill y -anchor nw
scrollbar .f.uf.f3.x -command ".f.uf.f3.cf.c xview" -orient h -bd 1 -relief sunken
pack .f.uf.f3.cf .f.uf.f3.x -side top -anchor ne
pack .f.uf.f3.cf -fill both -expand 1
pack .f.uf.f3.x -fill x
pack .f.uf.f3 -fill both -expand 1

frame .f.uf.f2
frame .f.uf.f2.cf
canvas .f.uf.f2.cf.c -xscrollcommand ".f.uf.f2.x set" -yscrollcommand ".f.uf.f2.cf.y set" -scrollregion {0 0 10000 2000}
font create .f.uf.f2.cf.c.f -family system -size 14
scrollbar .f.uf.f2.cf.y -command ".f.uf.f2.cf.c yview" -orient v -bd 1 -relief sunken
pack .f.uf.f2.cf.c .f.uf.f2.cf.y -side left
pack .f.uf.f2.cf.y -side right
pack .f.uf.f2.cf.c -fill both -expand 1 -anchor ne
pack .f.uf.f2.cf.y -fill y -anchor nw
scrollbar .f.uf.f2.x -command ".f.uf.f2.cf.c xview" -orient h -bd 1 -relief sunken
pack .f.uf.f2.cf .f.uf.f2.x -side top -anchor ne
pack .f.uf.f2.cf -fill both -expand 1
pack .f.uf.f2.x -fill x
pack .f.uf.f2 -fill both -expand 1

.f.uf add .f.uf.f3 .f.uf.f2

pack .f.f .f.uf -side top -anchor nw

pack .f.uf -expand 1 -fill both

pack .f -expand 1 -fill both

font create treefont -family system -size 14
proc mktext {t} {
    set id [.f.uf.f2.cf.c create text 0 0 -anchor n -text $t -font treefont]
    return $id
}

proc clearcanvas {} {
    .f.uf.f2.cf.c delete all
}

font create largefont -family system -weight bold -size 28
proc notree {} {
    clearcanvas
    .f.uf.f2.cf.c create text 60 5 -anchor n -text "No Tree" -font largefont -fill grey
}

proc size {id} {
    set box [.f.uf.f2.cf.c bbox $id]
    set width [expr {[lindex $box 2] - [lindex $box 0]}] 
    return $width
}

proc treewindow {w h} {
    global vsep
    .f.uf.f2.cf.c configure -width $w -height [expr $h*$vsep]
}

proc movenode {id x row} {
    global vsep
    .f.uf.f2.cf.c move $id $x [expr $row*$vsep]
}

proc relocate {id dx dy} {
    .f.uf.f2.cf.c move $id $dx $dy
}


proc branch {row c l r} {
    global vsep ff
    set v1 [expr $row*$vsep]
    set v2 [expr $v1+$vsep]
    .f.uf.f2.cf.c create line $l $v2 $c $v1 $r $v2 -width [expr int($ff)]
}

proc nbranch {row c bf args} {
    global vsep ff
    set v1 [expr $row*$vsep]
    set v2 [expr $v1+$vsep]
    set ls ""
    foreach br $args {
	if {$ls == ""} {
	    lappend ls $br $v2
	} else {
	    lappend ls $c $v1 $br $v2
	}
    }
    .f.uf.f2.cf.c create line $ls -width [expr int($ff)]
}

proc nobranch {row c} {
    global vsep ff
    set v1 [expr $row*$vsep]
    set v2 [expr $v1+$vsep]
    .f.uf.f2.cf.c create line $c $v2 $c $v1 -width [expr int($ff)]
}

proc setvsep {v} {
    global vsep
    set vsep $v
}

proc textfile {f1 f2} {
    global trees max cnt 
    if {($f1 == "No file set") || ($f2 == "No file set")} { 
	select_files_msg 
    } else {
    if {[file exists $f1]} {
	set id1 [open $f1]
	set data [read $id1]
	close $id1

	set lines [split $data "\n"]

	if {[file exists $f2]} {
	    set id2 [open $f2]
	    set data [read $id2]
	    close $id2

	    set trees [split $data "\n"]

	    .f.uf.f3.cf.c delete 1.0 end
	    bind .f.uf.f3.cf.c <KeyPress-Down> do_prolog_down
	    bind .f.uf.f3.cf.c <KeyPress-Up> do_prolog_up
	    reset_display 1

	    set i 0
	    foreach line $lines {
		.f.uf.f3.cf.c insert end [format "%s\n" $line]  $i
		.f.uf.f3.cf.c tag bind $i <ButtonPress> [list do_prolog $i]
		incr i
	    }
	    set max [expr $i-1]
	    set cnt $i
	    .f.uf.f3.cf.c mark set insert 1.0

	} else {
	    file_msg $f2
	}
	
    } else {
	file_msg $f1
    }
    }
}

proc redrawtree {f} {
    global last trees vsep
    set vsep [expr 15*$f]
    font configure treefont -size [expr int(14*$f)]
    prolog [format "setbranchsep(%f)" $f]
    if {$last >= 0} {
	prolog [lindex $trees $last]
    }
}

set last -1
proc do_prolog {i} {
    global last selt
    if {$last >= 0} {
	.f.uf.f3.cf.c tag configure $last -background white
    }

    .f.uf.f3.cf.c tag configure $i -background lightblue
    set selt [expr $i+1]
    set last $i
    display_tree $i
}

proc display_tree {i} {
    global trees scs

    prolog [lindex $trees $i]
    foreach sc $scs {
	if {[catch {puts $sc $i}]} {
	    connectionlost_msg $sc
	}
    }
}

proc do_prolog_down {} {
    global last max selt
    if {$last >= 0 && $last < $max} {
	.f.uf.f3.cf.c tag configure $last -background white
	next_down 
	.f.uf.f3.cf.c mark set insert $last.0
	.f.uf.f3.cf.c see insert
	.f.uf.f3.cf.c tag configure $last -background lightblue
	set selt [expr $last+1]
	display_tree $last
    }
}

proc next_down {} {
    global last selected
    if {$selected == 1} {
	set start [expr $last+1]
	set pair [.f.uf.f3.cf.c tag nextrange hlall $start.end]
	if {$pair != ""} {
	    set last [expr {int([lindex $pair 0]) - 1}]
	} 
    } else {
	incr last
    }
}

proc do_prolog_up {} {
    global last trees selt
    if {$last > 0} {
	.f.uf.f3.cf.c tag configure $last -background white
	next_up
	.f.uf.f3.cf.c tag configure $last -background lightblue
	set selt [expr $last+1]
	display_tree $last
    }
}

proc next_up {} {
    global last selected
    if {$selected == 1} {
	set pair [.f.uf.f3.cf.c tag prevrange hlall $last.end]
	if {$pair != ""} {
	    set last [expr {int([lindex $pair 0]) - 1}]
	} 
    } else {
	incr last -1
    }
}

proc goto_tree {} {
    global max last trees selt
    if {$selt != "(none)"} {
	if {$selt > 0 && $selt <= $max} {
	    .f.uf.f3.cf.c tag configure $last -background white
	    set last [expr $selt-1]
	    .f.uf.f3.cf.c tag configure $last -background lightblue
	    .f.uf.f3.cf.c mark set insert $last.0
	    .f.uf.f3.cf.c see insert
	    display_tree $last
	} else {
	    tk_messageBox -type ok -message [format "Sentence number %s is out of range!" $selt]
	}
    }
}

# tags: highlight hlall invis
.f.uf.f3.cf.c tag configure highlight -foreground red -background honeydew
.f.uf.f3.cf.c tag configure hlall -foreground red
.f.uf.f3.cf.c tag configure invis -elide 1
set highlightb -1

proc text_search_down {} {
    global ss p1 highlightb highlighte cb1
    set ss "Down"

    remove_highlights

    if {$p1 == ""} {
	return
    }

    if {$cb1 == 0} {
	set m [.f.uf.f3.cf.c search -forwards -count len $p1 insert end]
    } else {
	set m [.f.uf.f3.cf.c search -regexp -forwards -count len $p1 insert end]
    }

    if {$m != ""} {
	set highlightb $m
	set highlighte "$m + $len chars"
	.f.uf.f3.cf.c mark set insert $highlighte
	.f.uf.f3.cf.c see insert
	.f.uf.f3.cf.c tag add highlight $highlightb $highlighte
#	focus .f.uf.f3.cf.c
    } else {
	not_found_msg $p1
    }
}


proc text_search_up {} {
    global ss p1 highlightb highlighte cb1
    set ss "Up"

    remove_highlights

    if {$p1 == ""} {
	return
    }

    if {$cb1 == 0} {
	set m [.f.uf.f3.cf.c search -backwards -count len $p1 insert 1.0]
    } else {
	set m [.f.uf.f3.cf.c search -regexp -backwards -count len $p1 insert 1.0]
    }

    if {$m != ""} {
	set highlightb $m
	set highlighte "$m + $len chars"
	.f.uf.f3.cf.c mark set insert $highlightb
	.f.uf.f3.cf.c see insert
	.f.uf.f3.cf.c tag add highlight $highlightb $highlighte
#	focus .f.uf.f3.cf.c
    } else {
	not_found_msg $p1
    }
}

# one level "All" - disable other options - allow recursive?
proc text_search_all {} {
    global ss p1 cb1 sel
    set ss "All"
    
    remove_highlights

    if {$p1 == ""} {
	return
    }

    set m "None"
    .f.uf.f3.cf.c mark set insert 1.0
    
    set cnt 0
    while {$m != ""} {
	if {$cb1 == 0} {
	    set m [.f.uf.f3.cf.c search -count len $p1 insert end]
	} else {
	    set m [.f.uf.f3.cf.c search -regexp -count len $p1 insert end]
	}
	if {$m != ""} {
	    .f.uf.f3.cf.c mark set insert "$m + $len chars"
	    .f.uf.f3.cf.c tag add hlall $m "$m + $len chars"
	    incr cnt
	}
    }
    if {$cnt == 0} {
	not_found_msg $p1
    } else {
	set sel $cnt
	.f.f.f3.lb4 configure -foreground red
	.f.f.f3.lb3 configure -foreground black
	.f.f.f3.lb5 configure -foreground black
	.f.f.f3.b1 configure -state normal
    }
}

proc do_text_search {} {
    global p1 ss
    if {$p1 != ""} {
	if {$ss == "Down"} {
	    text_search_down
	} elseif {$ss == "Up"} {
	    text_search_up
	} else {
	    text_search_all
	}
    }
}

proc remove_highlights {} {
    global highlightb highlighte

    if {$highlightb >= 0} {
	.f.uf.f3.cf.c tag remove highlight $highlightb $highlighte
    }

    foreach {i j} [.f.uf.f3.cf.c tag ranges hlall] {
	.f.uf.f3.cf.c tag remove hlall $i $j
    }
}

proc select_files_msg {} {
    tk_messageBox -type ok -icon error -message "Select Sentence and Prolog Tree files first"
}

proc not_found_msg {s} {
    tk_messageBox -type ok -message [format "Search \"%s\" not found!" $s]
}

proc tree_not_found_msg {s} {
    tk_messageBox -type ok -message [format "Tree Search \"%s\" not found!" $s]
}

proc file_msg {s} {
    tk_messageBox -type ok -message [format "File %s not found!" $s]
}

# need to modify up and down to jump to the next highlighted case
proc show_selected {} {
    global max selected
    set l 0
    while {$l <= $max} {
	if {[.f.uf.f3.cf.c tag nextrange hlall $l.0 $l.end] == ""} {
	    .f.uf.f3.cf.c tag add invis $l.0 "$l.end +1 chars"
	}
	incr l
    }
    .f.f.f3.b1 configure -state disabled
    .f.f.f3.b2 configure -state normal
    .f.f.f2.f3 configure -state disabled
    .f.f.f2.cb1 configure -state disabled
    .f.f.f2.mb1 configure -state disabled
    set selected 1
    .f.f.f2.lb2 configure -state disabled
    .f.f.f2.f4 configure -state disabled
    .f.f.f2.mb2 configure -state disabled
}

proc show_all {} {
    foreach {i j}  [.f.uf.f3.cf.c tag ranges invis] {
	.f.uf.f3.cf.c tag remove invis $i $j
    }
    remove_highlights
    reset_display 0
}

proc load_treebank {f} {
    prolog [format "load_files('%s')" [lindex [split $f "."] 0]]
    .f.f.f2.b configure -text "Enabled" -state disabled
    .f.f.f2.lb2 configure -state normal
    .f.f.f2.f4 configure -state normal
    .f.f.f2.mb2 configure -state normal
}

proc do_tree_search {} {
    global p2 ts
    if {$p2 != ""} {
	if {$ts == "One"} {
	    tree_search_one
	} else {
	    tree_search_all
	}
    }
}

proc tree_search_one {} {
    global p2 ts
    set ts "One"
    if {[prolog [format "searchone((%s),I)" $p2]] == 1} {
	do_prolog $prolog_variables(I)
    } else {
	tree_not_found_msg $p2
    }
}

proc tree_search_all {} {
    global p2 max selected sel ts
    set ts "All"
    if {[prolog [format "searchall((%s),L)" $p2]] == 1} {
	set sel [llength $prolog_variables(L)]
	.f.f.f3.lb4 configure -foreground red
	.f.f.f3.lb3 configure -foreground black
	.f.f.f3.lb5 configure -foreground black
	.f.f.f3.b1 configure -state disabled
	.f.f.f3.b2 configure -state normal

	.f.f.f2.f3 configure -state disabled
	.f.f.f2.cb1 configure -state disabled
	.f.f.f2.lb2 configure -state disabled
	.f.f.f2.f4 configure -state disabled
	set selected 1
	set l 1
	foreach {i} $prolog_variables(L) {
	    while {$l <= $i} {
		.f.uf.f3.cf.c tag add invis $l.0 "$l.end +1 chars"
		incr l
	    }
	    .f.uf.f3.cf.c tag add hlall $l.0 $l.1
	    incr l
	}

	while {$l <= $max} {
	    .f.uf.f3.cf.c tag add invis $l.0 "$l.end +1 chars"
	    incr l
	}
    } else {
	tree_not_found_msg $p2
    }
}

proc reset_display {flag} {
    global selt sel cnt selected
    set selected 0
    set sel "(none)"
    .f.f.f3.b1 configure -state disabled
    .f.f.f3.b2 configure -state disabled
    .f.f.f3.lb3 configure -foreground grey
    .f.f.f3.lb4 configure -foreground grey
    .f.f.f3.lb5 configure -foreground grey

    .f.f.f2.f3 configure -state normal
    .f.f.f2.cb1 configure -state normal
    .f.f.f2.mb1 configure -state normal

    if {[.f.f.f2.b cget -text] == "Enabled" } {
	.f.f.f2.lb2 configure -state normal
	.f.f.f2.f4 configure -state normal
	.f.f.f2.mb2 configure -state normal
    }

    if {$flag==1} {
	set cnt 0
	set selt "(none)"
	clearcanvas
	.f.f.f2.b configure -text "Enable" -state normal
	.f.f.f2.lb2 configure -state disabled
	.f.f.f2.f4 configure -state disabled
    }
}

set port 2001
set scs ""
proc do_sync {} {
    global port scs
    
    if {[catch {set sc [socket 127.0.0.1 $port]}]} {
	noviewer_msg $port
    } else {
	fconfigure $sc -buffering line
	lappend scs $sc
	viewer_msg $port $scs
	incr port
    }
}

proc connectionlost_msg {sc} {
    tk_messageBox -type ok -message [format "Lost connection with Treebankviewer\n (%s)" $sc]
}

proc noviewer_msg {s} {
    tk_messageBox -type ok -message [format "Unable to synchronize!\nTreebankviewer %s not found." [expr $s-2000]]
}

proc viewer_msg {port scs} {
    tk_messageBox -type ok -message [format "Sync established with Treebankviewer %s\n(%s)" [expr $port-2000] $scs]
}
